Index: /trunk/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSlice.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComSlice.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -1315,5 +1315,5 @@
 
   Bool    getViewCompLayerPresentFlag (Int i, Bool d ) const                    { return  m_viewCompLayerPresentFlag[ getVoiInVps(i) ][d]; }
-  Bool    getViewCompLayerId          (Int i, Bool d ) const                    { return  m_viewCompLayerId         [ getVoiInVps(i) ][d]; }
+  Int     getViewCompLayerId          (Int i, Bool d ) const                    { return  m_viewCompLayerId         [ getVoiInVps(i) ][d]; }
 #endif
   Bool    getDependencyFlag( Int i, Int j ) const                               { return m_dependencyFlag[i][j]; }
@@ -1352,9 +1352,16 @@
 
   Bool    isOutputLayer( Int outLayerSetIdx, Int layerIdInNuh )  const;    
+  Bool    isIndependendNonBaseLayer    ( Int layerIdInNuh )      const    {       return (layerIdInNuh > 0) && getNumRefLayers( layerIdInNuh ) == 0 ; };
+#if NH_3D
+  Bool    isFirstDepthLayer            ( Int layerIdInNuh )      const;
+#endif
+
   Void    deriveLayerSetLayerIdList();
 
   Int     olsIdxToLsIdx( Int i )                                       const    { return ( i < getNumLayerSets() ) ? i  : getLayerSetIdxForOlsMinus1( i ) + 1 ; };
+
   Void    initTargetLayerIdLists  ( );
   Void    deriveTargetLayerIdList ( Int i );
+  
   std::vector<Int> getTargetDecLayerIdList( Int targetDecLayerSetIdx ) const     { return m_targetDecLayerIdLists[targetDecLayerSetIdx]; }; 
   std::vector<Int> getTargetOptLayerIdList( Int targetOptLayerSetIdx ) const     { return m_targetOptLayerIdLists[targetOptLayerSetIdx]; }; 
@@ -1377,8 +1384,10 @@
   // helpers
   Void    printPTL()                                                   const;
+  Void    printRepFormat()                                             const;
   Void    printLayerDependencies()                                     const;
   Void    printScalabilityId()                                         const;
   Void    printLayerSets()                                             const;
 
+  IntAry1d  getLayersOfVpsPtl( Int idxOfVpsPtl )                       const;
 
   /// VPS EXTENSION 2 SYNTAX ELEMENTS
@@ -1427,10 +1436,10 @@
 #endif
 
-  template <typename T, typename S, typename U> Void xPrintArray( const TChar* name, Int numElemDim1, U idx, S numElemDim2, T vec, Bool printNumber, Bool printIdx = true ) const
+  template <typename T, typename S, typename U> Void xPrintArray( const TChar* name, Int numElemDim1, U idx, S numElemDim2, T vec, Bool printNumber, Bool printIdx = true, Int elemDist = 3 ) const
   {
     std::cout << std::endl; 
     for (Int j = 0; j < numElemDim1; j++ )
     { 
-      std::cout << std::right << std::setw(27) << name; 
+      std::cout << std::right << std::setw(40) << name; 
       if (printIdx)
       {
@@ -1454,5 +1463,5 @@
       for (Int i = 0; i < numElemDim2[j]; i++)
       {
-        std::cout << std::right << std::setw(3) << vec[j][i];
+        std::cout << std::right << std::setw(elemDist) << vec[j][i];
       }   
       std::cout << std::endl; 
@@ -1460,16 +1469,17 @@
   }
 
-  template <typename T> Void xPrintArray( const char* name, Int numElem, T vec, Bool printNumber  )  const
+  template <typename T> Void xPrintArray( const char* name, Int numElem, T vec, Bool printNumber, Int elemDist = 3  )  const
   {
     std::vector<Int> numElemDim2(1, numElem);    
     std::vector<T>   vec2       (1,  vec    );
     std::vector<Int> idx2       (0); 
-    xPrintArray( name, 1, idx2, numElemDim2, vec2, printNumber, false );
+    xPrintArray( name, 1, idx2, numElemDim2, vec2, printNumber, false, elemDist );
   }
 
 #endif
+
 };
 
-#if NH_3D_DLT
+#if NH_3D
 class TComDLT
 {
@@ -1491,5 +1501,5 @@
 
 public:
-  TComDLT();
+  TComDLT( );
   ~TComDLT();
   
@@ -1811,18 +1821,18 @@
     for (Int d = 0; d < 2; d++)
     {
-      m_ivDiMcEnabledFlag          [d] = false; 
-      m_ivMvScalEnabledFlag       [d] = false; 
-      m_log2IvmcSubPbSizeMinus3   [d] = 3; 
-      m_ivResPredEnabledFlag         [d] = false; 
-      m_depthRefEnabledFlag   [d] = false; 
-      m_vspMcEnabledFlag [d] = false; 
-      m_dbbpEnabledFlag [d] = false; 
-      m_texMcEnabledFlag               [d] = false; 
-      m_log2TexmcSubPbSizeMinus3[d] = 3; 
-      m_intraContourEnabledFlag      [d] = false; 
+      m_ivDiMcEnabledFlag               [d] = false; 
+      m_ivMvScalEnabledFlag             [d] = false; 
+      m_log2IvmcSubPbSizeMinus3         [d] = 3; 
+      m_ivResPredEnabledFlag            [d] = false; 
+      m_depthRefEnabledFlag             [d] = false; 
+      m_vspMcEnabledFlag                [d] = false; 
+      m_dbbpEnabledFlag                 [d] = false; 
+      m_texMcEnabledFlag                [d] = false; 
+      m_log2TexmcSubPbSizeMinus3        [d] = 3; 
+      m_intraContourEnabledFlag         [d] = false; 
       m_intraDcOnlyWedgeEnabledFlag     [d] = false; 
-      m_cqtCuPartPredEnabledFlag            [d] = false; 
+      m_cqtCuPartPredEnabledFlag        [d] = false; 
       m_interDcOnlyEnabledFlag          [d] = false; 
-      m_skipIntraEnabledFlag    [d] = false;   
+      m_skipIntraEnabledFlag            [d] = false;   
     }
   }
@@ -1917,5 +1927,5 @@
 #endif
   Bool             m_bLongTermRefsPresent;
-  Bool             m_TMVPFlagsPresent;
+  Bool             m_SPSTemporalMVPEnabledFlag;
   Int              m_numReorderPics[MAX_TLAYER];
 
@@ -1974,5 +1984,5 @@
   UInt             m_forceDecodeBitDepth; // 0 = do not force the decoder's bit depth, other = force the decoder's bit depth to this value (best effort decoding)
 #endif
-#if NH_MV
+#if NH_MV  
   TComVPS*         m_pcVPS; 
   // SPS           
@@ -2001,4 +2011,5 @@
 #if NH_MV           
   Int              m_layerId; 
+  TComRepFormat*   m_inferredRepFormat;
 #endif
 
@@ -2025,4 +2036,5 @@
   UInt                   getPicWidthInLumaSamples() const                                                { return  m_picWidthInLumaSamples;                                     }
   Void                   setPicHeightInLumaSamples( UInt u )                                             { m_picHeightInLumaSamples = u;                                        }
+  
   UInt                   getPicHeightInLumaSamples() const                                               { return  m_picHeightInLumaSamples;                                    }
 
@@ -2092,8 +2104,8 @@
   Void                   setLongTermRefsPresent(Bool b)                                                  { m_bLongTermRefsPresent=b;                                            }
 #endif
-  Bool                   getTMVPFlagsPresent() const                                                     { return m_TMVPFlagsPresent;                                           }
-  Void                   setTMVPFlagsPresent(Bool b)                                                     { m_TMVPFlagsPresent=b;                                                }
-#if NH_MV
-  Bool                   getSpsTemporalMvpEnabledFlag() const                                            { return m_TMVPFlagsPresent;                                           }
+  Bool                   getSPSTemporalMVPEnabledFlag() const                                            { return m_SPSTemporalMVPEnabledFlag;                                  }
+  Void                   setSPSTemporalMVPEnabledFlag(Bool b)                                            { m_SPSTemporalMVPEnabledFlag=b;                                       }
+#if NH_MV
+  Bool                   getSpsTemporalMvpEnabledFlag() const                                            { return m_SPSTemporalMVPEnabledFlag;                                           }
 #endif
   // physical transform
@@ -2103,4 +2115,5 @@
   // Bit-depth
   Int                    getBitDepth(ChannelType type) const                                             { return m_bitDepths.recon[type];                                      }
+
   Void                   setBitDepth(ChannelType type, Int u )                                           { m_bitDepths.recon[type] = u;                                         }
 #if O0043_BEST_EFFORT_DECODING
@@ -2219,5 +2232,5 @@
   // Inference          
                         
-  Void                   inferRepFormat( TComVPS* vps, Int layerIdCurr, Bool encoder );
+  Void                   inferRepFormat  ( TComVPS* vps, Int layerIdCurr, Bool alreadySet );
   Void                   inferScalingList( const TComSPS* spsSrc );
                         
@@ -2358,5 +2371,5 @@
   Bool             m_useWeightedBiPred;                 //!< Use of Weighting Bi-Prediction (B_SLICE)
   Bool             m_OutputFlagPresentFlag;             //!< Indicates the presence of output_flag in slice header
-  Bool             m_TransquantBypassEnableFlag;        //!< Indicates presence of cu_transquant_bypass_flag in CUs.
+  Bool             m_TransquantBypassEnabledFlag;       //!< Indicates presence of cu_transquant_bypass_flag in CUs.
   Bool             m_useTransformSkip;
   Bool             m_dependentSliceSegmentsEnabledFlag; //!< Indicates the presence of dependent slices
@@ -2371,5 +2384,5 @@
   std::vector<Int> m_tileRowHeight;
 
-  Bool             m_signHideFlag;
+  Bool             m_signDataHidingEnabledFlag;
 
   Bool             m_cabacInitPresentFlag;
@@ -2379,5 +2392,5 @@
   Bool             m_deblockingFilterControlPresentFlag;
   Bool             m_deblockingFilterOverrideEnabledFlag;
-  Bool             m_picDisableDeblockingFilterFlag;
+  Bool             m_ppsDeblockingFilterDisabledFlag;
   Int              m_deblockingFilterBetaOffsetDiv2;    //< beta offset for deblocking filter
   Int              m_deblockingFilterTcOffsetDiv2;      //< tc offset for deblocking filter
@@ -2403,5 +2416,5 @@
 #endif
 
-#if NH_3D_DLT
+#if NH_3D
   TComDLT                m_cDLT;
 #endif
@@ -2428,5 +2441,5 @@
   UInt                   getMaxCuDQPDepth() const                                         { return m_uiMaxCuDQPDepth;                     }
 
-#if NH_3D_DLT
+#if NH_3D
   Void                   setDLT( TComDLT cDLT )                                           { m_cDLT = cDLT;                                }
   const TComDLT*         getDLT() const                                                   { return &m_cDLT;                               }
@@ -2467,6 +2480,6 @@
   Void                   setOutputFlagPresentFlag( Bool b )                               { m_OutputFlagPresentFlag = b;                  }
   Bool                   getOutputFlagPresentFlag() const                                 { return m_OutputFlagPresentFlag;               }
-  Void                   setTransquantBypassEnableFlag( Bool b )                          { m_TransquantBypassEnableFlag = b;             }
-  Bool                   getTransquantBypassEnableFlag() const                            { return m_TransquantBypassEnableFlag;          }
+  Void                   setTransquantBypassEnabledFlag( Bool b )                         { m_TransquantBypassEnabledFlag = b;            }
+  Bool                   getTransquantBypassEnabledFlag() const                           { return m_TransquantBypassEnabledFlag;         }
 
   Bool                   getUseTransformSkip() const                                      { return m_useTransformSkip;                    }
@@ -2493,6 +2506,6 @@
   UInt                   getTileRowHeight(UInt rowIdx) const                              { return m_tileRowHeight[rowIdx];               }
 
-  Void                   setSignHideFlag( Bool signHideFlag )                             { m_signHideFlag = signHideFlag;                }
-  Bool                   getSignHideFlag() const                                          { return m_signHideFlag;                        }
+  Void                   setSignDataHidingEnabledFlag( Bool b )                           { m_signDataHidingEnabledFlag = b;              }
+  Bool                   getSignDataHidingEnabledFlag() const                             { return m_signDataHidingEnabledFlag;           }
 
   Void                   setCabacInitPresentFlag( Bool flag )                             { m_cabacInitPresentFlag = flag;                }
@@ -2502,6 +2515,6 @@
   Void                   setDeblockingFilterOverrideEnabledFlag( Bool val )               { m_deblockingFilterOverrideEnabledFlag = val;  }
   Bool                   getDeblockingFilterOverrideEnabledFlag() const                   { return m_deblockingFilterOverrideEnabledFlag; }
-  Void                   setPicDisableDeblockingFilterFlag(Bool val)                      { m_picDisableDeblockingFilterFlag = val;       } //!< set offset for deblocking filter disabled
-  Bool                   getPicDisableDeblockingFilterFlag() const                        { return m_picDisableDeblockingFilterFlag;      } //!< get offset for deblocking filter disabled
+  Void                   setPPSDeblockingFilterDisabledFlag(Bool val)                     { m_ppsDeblockingFilterDisabledFlag = val;      } //!< set offset for deblocking filter disabled
+  Bool                   getPPSDeblockingFilterDisabledFlag() const                       { return m_ppsDeblockingFilterDisabledFlag;     } //!< get offset for deblocking filter disabled
   Void                   setDeblockingFilterBetaOffsetDiv2(Int val)                       { m_deblockingFilterBetaOffsetDiv2 = val;       } //!< set beta offset for deblocking filter
   Int                    getDeblockingFilterBetaOffsetDiv2() const                        { return m_deblockingFilterBetaOffsetDiv2;      } //!< get beta offset for deblocking filter
@@ -2726,26 +2739,18 @@
   Int        m_pocMsbCycleVal;
   Bool       m_pocMsbValRequiredFlag;
+#endif
 
 #if NH_3D
   IntAry2d   m_aaiCodedScale ;
   IntAry2d   m_aaiCodedOffset;
-#endif
-#if NH_3D_TMVP
+
   Int        m_aiAlterRefIdx   [2]; 
-#endif
-#if NH_3D_ARP
   Bool       m_arpRefPicAvailable[2][MAX_NUM_LAYERS];
   TComList<TComPic*> * m_pBaseViewRefPicList[MAX_NUM_LAYERS];
   UInt        m_nARPStepNum; 
   Int         m_aiFirstTRefIdx    [2];   
-#endif
-#if NH_3D
   std::vector<Int> m_pocsInCurrRPSs; 
-#endif
-#if NH_3D_IC
   Bool       m_bApplyIC;
   Bool       m_icSkipParseFlag;
-#endif
-#if NH_3D
   std::vector<Int> m_inCmpRefViewIdcs;
   Bool       m_inCmpPredAvailFlag; 
@@ -2753,19 +2758,11 @@
   Bool       m_cpAvailableFlag; 
   Int        m_numViews; 
-#endif
-#if NH_3D_QTL
   TComPic*   m_ivPicsCurrPoc [2][MAX_NUM_LAYERS];  
-#endif
-#if NH_3D
   Int**      m_depthToDisparityB; 
   Int**      m_depthToDisparityF; 
   Bool       m_bApplyDIS;
-#endif
-#endif
-#if NH_3D_IC
   Int*       m_aICEnableCandidate;
   Int*       m_aICEnableNum;
-#endif       
-#if NH_3D   
+
   Int        m_iDefaultRefViewIdx;
   Bool       m_bDefaultRefViewIdxAvailableFlag;
@@ -2844,4 +2841,5 @@
   Int                         getNumRefIdx( RefPicList e ) const                     { return m_aiNumRefIdx[e];                                      }
   TComPic*                    getPic()                                               { return m_pcPic;                                               }
+  const TComPic*              getPic() const                                         { return m_pcPic;                                               }
   TComPic*                    getRefPic( RefPicList e, Int iRefIdx)                  { return m_apcRefPicList[e][iRefIdx];                           }
   const TComPic*              getRefPic( RefPicList e, Int iRefIdx) const            { return m_apcRefPicList[e][iRefIdx];                           }
@@ -2855,10 +2853,6 @@
   Int                         getNumCurCmpLIds( )                      const         { return (Int) m_inCmpRefViewIdcs.size();                       }
   TComPic*                    getIvPic( Bool depthFlag, Int viewIndex) const         { return  m_ivPicsCurrPoc[ depthFlag ? 1 : 0 ][ viewIndex ];    }
-#endif
-#if NH_3D_QTL
   TComPic*                    getTexturePic       ()                                 { return  m_ivPicsCurrPoc[0][ m_viewIndex ];                    }
 
-#endif                            
-#if NH_3D_IC                                                                                                                                          
   Void                        setApplyIC( Bool b )                                   { m_bApplyIC = b;                                               }
   Bool                        getApplyIC()                                           { return m_bApplyIC;                                            }
@@ -2867,6 +2861,5 @@
   Void                        setIcSkipParseFlag( Bool b )                           { m_icSkipParseFlag = b;                                        }
   Bool                        getIcSkipParseFlag()                                   { return m_icSkipParseFlag;                                     }
-#endif                                                                                                                                               
-#if NH_3D_ARP                                                                                                                                         
+
   Void                        setBaseViewRefPicList( TComList<TComPic*> *pListPic, Int iViewIdx )      { m_pBaseViewRefPicList[iViewIdx] = pListPic; }                  
   Void                        setARPStepNum( TComPicLists*ivPicLists );                                                                              
@@ -3155,10 +3148,7 @@
 
 #if NH_3D
-#if NH_3D_TMVP
   Void                        generateAlterRefforTMVP ();   
   Void                        setAlterRefIdx          ( RefPicList e, Int i )        { m_aiAlterRefIdx[e]    = i;                                    }
   Int                         getAlterRefIdx          ( RefPicList e )               { return  m_aiAlterRefIdx[e];                                   }
-#endif                                                                                                                                               
-#if NH_3D_ARP                                                                                                                                         
   Int                         getFirstTRefIdx        ( RefPicList e )                { return  m_aiFirstTRefIdx[e];                                  }
   Void                        setFirstTRefIdx        ( RefPicList e, Int i )         { m_aiFirstTRefIdx[e]    = i;                                   }
@@ -3166,5 +3156,4 @@
   Bool                        getArpRefPicAvailable  ( RefPicList e, Int viewIdx)    { return m_arpRefPicAvailable[e][getVPS()->getLayerIdInNuh(viewIdx, false, 0 )]; }
   IntAry1d                    getPocsInCurrRPSs()                                    { return m_pocsInCurrRPSs;                                      } 
-#endif                        
 #endif
 #if NH_3D_VSO || NH_3D
@@ -3192,14 +3181,11 @@
   Int                         getCpInvOff( Int j )                                   { return m_aaiCodedOffset[1][j];                                }
                                                                                                                                                         
-#endif
-#if NH_3D_QTL
   Void                        setIvPicLists( TComPicLists* m_ivPicLists );                                                                              
-#endif
-#if NH_3D
+
   Void                        setDepthToDisparityLUTs();                                                                                                
                                                                                                                                                         
   Int*                        getDepthToDisparityB( Int refViewIdx )                 { return m_depthToDisparityB[ getVPS()->getVoiInVps( refViewIdx) ];}
   Int*                        getDepthToDisparityF( Int refViewIdx )                 { return m_depthToDisparityF[ getVPS()->getVoiInVps( refViewIdx) ];}
-#if NH_3D_IC                                                                                                                                             
+
   Void                        setICEnableCandidate( Int* icEnableCandidate)          { m_aICEnableCandidate = icEnableCandidate;                     }
   Void                        setICEnableNum( Int* icEnableNum)                      { m_aICEnableNum = icEnableNum;                                 }
@@ -3209,5 +3195,4 @@
   Int                         getICEnableCandidate( Int layer)                       { return  m_aICEnableCandidate[ layer ];                        }
   Int                         getICEnableNum( Int layer)                             { return m_aICEnableNum[ layer ];                               }
-#endif
 #endif
 // Additional slice header syntax elements
@@ -3335,5 +3320,5 @@
   Int                         getMpiSubPbSize           ( )                          { return m_mpiSubPbSize           ;                             };
   Int                         getSubPbSize              ( )                          { return m_subPbSize              ;                             };
-#if NH_3D_NBDV
+
   Int                         getDefaultRefViewIdx()                                 { return m_iDefaultRefViewIdx;                                  }
   Void                        setDefaultRefViewIdx(Int iViewIdx)                     { m_iDefaultRefViewIdx = iViewIdx;                              }
@@ -3343,5 +3328,4 @@
   Void                        setDefaultRefView( );
 #endif
-#endif
 #if NH_MV
  TComPic*                     getRefPicSetInterLayer( Int setIdc, Int i ) const; 
@@ -3364,5 +3348,5 @@
 
 
-Void calculateParameterSetChangedFlag(Bool &bChanged, const std::vector<UChar> *pOldData, const std::vector<UChar> &newData);
+Void calculateParameterSetChangedFlag(Bool &bChanged, const std::vector<UChar> *pOldData, const std::vector<UChar> *pNewData);
 
 template <class T> class ParameterSetMap
@@ -3390,5 +3374,18 @@
   }
 
-  Void storePS(Int psId, T *ps, const std::vector<UChar> &naluData)
+  T *allocatePS(const Int psId)
+  {
+    assert ( psId < m_maxId );
+    if ( m_paramsetMap.find(psId) == m_paramsetMap.end() )
+    {
+      m_paramsetMap[psId].bChanged = true;
+      m_paramsetMap[psId].pNaluData=0;
+      m_paramsetMap[psId].parameterSet = new T;
+      setID(m_paramsetMap[psId].parameterSet, psId);
+    }
+    return m_paramsetMap[psId].parameterSet;
+  }
+
+  Void storePS(Int psId, T *ps, const std::vector<UChar> *pNaluData)
   {
     assert ( psId < m_maxId );
@@ -3398,5 +3395,5 @@
 
       // work out changed flag
-      calculateParameterSetChangedFlag(mapData.bChanged, mapData.pNaluData, naluData);
+      calculateParameterSetChangedFlag(mapData.bChanged, mapData.pNaluData, pNaluData);
       delete m_paramsetMap[psId].pNaluData;
       delete m_paramsetMap[psId].parameterSet;
@@ -3409,6 +3406,21 @@
       m_paramsetMap[psId].bChanged = false;
     }
+    if (pNaluData != 0)
+    {
       m_paramsetMap[psId].pNaluData=new std::vector<UChar>;
-    *(m_paramsetMap[psId].pNaluData) = naluData;
+      *(m_paramsetMap[psId].pNaluData) = *pNaluData;
+    }
+    else
+    {
+      m_paramsetMap[psId].pNaluData=0;
+    }
+  }
+
+  Void setChangedFlag(Int psId, Bool bChanged=true)
+  {
+    if ( m_paramsetMap.find(psId) != m_paramsetMap.end() )
+    {
+      m_paramsetMap[psId].bChanged=bChanged;
+    }
   }
 
@@ -3451,4 +3463,6 @@
   std::map<Int,MapData<T> > m_paramsetMap;
   Int                       m_maxId;
+
+  static Void setID(T* parameterSet, const Int psId);
 };
 
@@ -3460,5 +3474,5 @@
 
   //! store sequence parameter set and take ownership of it
-  Void           storeVPS(TComVPS *vps, const std::vector<UChar> &naluData) { m_vpsMap.storePS( vps->getVPSId(), vps, naluData); };
+  Void           storeVPS(TComVPS *vps, const std::vector<UChar> &naluData) { m_vpsMap.storePS( vps->getVPSId(), vps, &naluData); };
   //! get pointer to existing video parameter set
   TComVPS*       getVPS(Int vpsId)                                           { return m_vpsMap.getPS(vpsId); };
@@ -3468,5 +3482,5 @@
 
   //! store sequence parameter set and take ownership of it
-  Void           storeSPS(TComSPS *sps, const std::vector<UChar> &naluData) { m_spsMap.storePS( sps->getSPSId(), sps, naluData); };
+  Void           storeSPS(TComSPS *sps, const std::vector<UChar> &naluData) { m_spsMap.storePS( sps->getSPSId(), sps, &naluData); };
   //! get pointer to existing sequence parameter set
   TComSPS*       getSPS(Int spsId)                                           { return m_spsMap.getPS(spsId); };
@@ -3476,5 +3490,5 @@
 
   //! store picture parameter set and take ownership of it
-  Void           storePPS(TComPPS *pps, const std::vector<UChar> &naluData) { m_ppsMap.storePS( pps->getPPSId(), pps, naluData); };
+  Void           storePPS(TComPPS *pps, const std::vector<UChar> &naluData) { m_ppsMap.storePS( pps->getPPSId(), pps, &naluData); };
   //! get pointer to existing picture parameter set
   TComPPS*       getPPS(Int ppsId)                                           { return m_ppsMap.getPS(ppsId); };
@@ -3502,13 +3516,26 @@
 
 #if NH_MV  
-  const TComSPS* getActiveSPS( Int layer )const { return m_spsMap.getPS(m_activeSPSId[layer]); };
+  const TComSPS* getActiveSPS( Int layer )const { return m_spsActiveForLayer.getPS(layer); };
 #else  
   const TComSPS* getActiveSPS()const { return m_spsMap.getPS(m_activeSPSId); };
 #endif
 
+#if NH_MV
+  Void          setSpsActiveForLayer( Int layer, TComSPS*& ps  )
+  {
+    TComSPS* psCopy = m_spsActiveForLayer.allocatePS( layer );
+    (*psCopy) = (*ps);
+    ps = psCopy;
+  }
+#endif
 protected:
   ParameterSetMap<TComVPS> m_vpsMap;
   ParameterSetMap<TComSPS> m_spsMap;
   ParameterSetMap<TComPPS> m_ppsMap;
+
+#if NH_MV
+  // As several SPS syntax elements be might inferred depending for the current layer, copies are stored for each layer  
+  ParameterSetMap<TComSPS> m_spsActiveForLayer;  
+#endif
 
   Int m_activeVPSId; // -1 for nothing active
Index: /trunk/source/Lib/TLibCommon/TComTU.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComTU.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComTU.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComTU.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComTU.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComTU.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComTrQuant.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComTrQuant.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComTrQuant.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -1153,8 +1153,6 @@
   if ( useRDOQ && (isLuma(compID) || RDOQ_CHROMA) )
   {
-#if T0196_SELECTIVE_RDOQ
     if ( !m_useSelectiveRDOQ || xNeedRDOQ( rTu, piCoef, compID, cQP ) )
     {
-#endif
 #if ADAPTIVE_QP_SELECTION
       xRateDistOptQuant( rTu, piCoef, pDes, pArlDes, uiAbsSum, compID, cQP );
@@ -1162,5 +1160,4 @@
       xRateDistOptQuant( rTu, piCoef, pDes, uiAbsSum, compID, cQP );
 #endif
-#if T0196_SELECTIVE_RDOQ
     }
     else
@@ -1169,5 +1166,4 @@
       uiAbsSum = 0;
     }
-#endif
   }
   else
@@ -1243,5 +1239,5 @@
     } // for n
 
-    if( pcCU->getSlice()->getPPS()->getSignHideFlag() )
+    if( pcCU->getSlice()->getPPS()->getSignDataHidingEnabledFlag() )
     {
       if(uiAbsSum >= 2) //this prevents TUs with only one coefficient of value 1 from being tested
@@ -1254,5 +1250,4 @@
 }
 
-#if T0196_SELECTIVE_RDOQ
 Bool TComTrQuant::xNeedRDOQ( TComTU &rTu, TCoeff * pSrc, const ComponentID compID, const QpParam &cQP )
 {
@@ -1310,5 +1305,4 @@
   return false;
 }
-#endif
 
 Void TComTrQuant::xDeQuant(       TComTU        &rTu,
@@ -1434,7 +1428,5 @@
                           Bool  bUseRDOQ,
                           Bool  bUseRDOQTS,
-#if T0196_SELECTIVE_RDOQ
                           Bool  useSelectiveRDOQ,
-#endif
                           Bool  bEnc,
                           Bool  useTransformSkipFast
@@ -1448,7 +1440,5 @@
   m_useRDOQ      = bUseRDOQ;
   m_useRDOQTS    = bUseRDOQTS;
-#if T0196_SELECTIVE_RDOQ
   m_useSelectiveRDOQ = useSelectiveRDOQ;
-#endif
 #if ADAPTIVE_QP_SELECTION
   m_bUseAdaptQpSelect = bUseAdaptQpSelect;
@@ -2538,5 +2528,5 @@
 
 
-  if( pcCU->getSlice()->getPPS()->getSignHideFlag() && uiAbsSum>=2)
+  if( pcCU->getSlice()->getPPS()->getSignDataHidingEnabledFlag() && uiAbsSum>=2)
   {
     const Double inverseQuantScale = Double(g_invQuantScales[cQP.rem]);
Index: /trunk/source/Lib/TLibCommon/TComTrQuant.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComTrQuant.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComTrQuant.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -106,7 +106,5 @@
                               Bool useRDOQ                = false,
                               Bool useRDOQTS              = false,
-#if T0196_SELECTIVE_RDOQ
                               Bool useSelectiveRDOQ       = false,
-#endif
                               Bool bEnc                   = false,
                               Bool useTransformSkipFast   = false
@@ -219,7 +217,5 @@
   Bool     m_useRDOQ;
   Bool     m_useRDOQTS;
-#if T0196_SELECTIVE_RDOQ
   Bool     m_useSelectiveRDOQ;
-#endif
 #if ADAPTIVE_QP_SELECTION
   Bool     m_bUseAdaptQpSelect;
@@ -254,10 +250,8 @@
                const QpParam      &cQP );
 
-#if T0196_SELECTIVE_RDOQ
   Bool xNeedRDOQ(    TComTU       &rTu,
                      TCoeff      * pSrc,
                const ComponentID   compID,
                const QpParam      &cQP );
-#endif
 
   // RDOQ functions
Index: /trunk/source/Lib/TLibCommon/TComWedgelet.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 1413)
@@ -45,5 +45,5 @@
 using namespace std;
 
-#if NH_3D_DMM
+#if NH_3D
 TComWedgelet::TComWedgelet( UInt uiWidth, UInt uiHeight ) : m_uhXs     ( 0 ),
                                                             m_uhYs     ( 0 ),
@@ -345,3 +345,3 @@
   m_uiRefineIdx[uiPos] = uiIdx;  
 }
-#endif //NH_3D_DMM
+#endif //NH_3D
